"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PromiseButton = void 0;

var _preact = require("preact");

var _classnames = _interopRequireDefault(require("classnames"));

var _button = require("./button");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

class PromiseButton extends _preact.Component {
  constructor(props) {
    super(props);
    this.state = {
      state: 'idle'
    };

    this.updateState = state => this.setState({
      state
    });
  }

  render(_ref, {
    state
  }) {
    let {
      buttonText,
      loadingText,
      icon,
      errorIcon = 'error',
      errorText,
      successText,
      resetTimeout,
      onClick
    } = _ref,
        rest = _objectWithoutProperties(_ref, ["buttonText", "loadingText", "icon", "errorIcon", "errorText", "successText", "resetTimeout", "onClick"]);

    const loading = state === 'loading';
    const error = state === 'error';
    const success = state === 'success';
    const disabled = error || loading || success || rest.disabled;
    const text = success && successText || loading && loadingText || error && errorText || buttonText;
    const activeIcon = loading && 'autorenew' || error && errorIcon || icon;
    return (0, _preact.h)(_button.IconButton, _extends({
      icon: activeIcon,
      iconClassName: (0, _classnames.default)(loading ? 'spin-animation' : null),
      disabled: disabled,
      onClick: () => {
        this.updateState('loading');
        onClick().then(() => {
          this.updateState('success');
        }).catch(() => {
          this.updateState('error');
        }).then(() => {
          if (resetTimeout) {
            setTimeout(() => this.updateState('idle'), resetTimeout);
          }
        });
      }
    }, rest), text);
  }

}

exports.PromiseButton = PromiseButton;